<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\User;
use Illuminate\Support\Facades\Hash;
use App\Models\UploadedFile;
use Illuminate\Support\Facades\Storage;

class FileUploadController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     */
    public function show(string $id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, string $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(string $id)
    {
        //
    }

    public function upload(Request $request)
    {

        // dd($request->toArray());

        // $postData = $request->all();

        $request->validate([
            'file' => 'required|file|mimes:jpg,jpeg,png,pdf|max:2048',
        ]);

        $userExists = User::where('email', $request->email)->exists();

        if ($userExists) {
            $userExistsNew = User::where('email', $request->email)->first();
            if ($request->hasFile('file')) {
                $file = $request->file('file');
                $path = $file->store('uploads', 'public');
                $fileType = $file->getMimeType();

                $uploadedFile = new UploadedFile();
                $uploadedFile->user_id = $userExistsNew->id;
                $uploadedFile->name = $request->filename;
                $uploadedFile->decription = $request->decription;
                $uploadedFile->eventmood = $request->eventmood;
                $uploadedFile->eventType = $request->eventType;
                $uploadedFile->fileType = $fileType;
                $uploadedFile->path = $path;
                $uploadedFile->save();

                if($uploadedFile){
                    return response()->json([
                        'success' => true,
                        'message' => 'File uploaded successfully!',
                        'path' => $path,
                    ]);
                }else{
                    return response()->json([
                        'success' => false,
                        'message' => 'File upload failed!',
                    ], 400);
                }
            }
        } else {

            // dd("User does not exist.");
            $userData = [
                'name' => $request->name,
                'email' => $request->email,
                'password' => Hash::make('password'), // Ensure to hash the password
                'mobile' => $request->phoneNumber,
            ];

            // Create a new user
            $user = User::create($userData);

            if ($user) {
                // dd("User created successfully.");

                // Handle the uploaded file
                if ($request->hasFile('file')) {
                    $file = $request->file('file');
                    $path = $file->store('uploads', 'public');

                    $uploadedFile = new UploadedFile();
                    $uploadedFile->user_id = $user->id;
                    $uploadedFile->name = $request->filename;
                    $uploadedFile->decription = $request->decription;
                    $uploadedFile->eventmood = $request->eventmood;
                    $uploadedFile->eventType = $request->eventType;
                    $uploadedFile->path = $path;
                    $uploadedFile->save();

                    if($uploadedFile){
                        return response()->json([
                            'success' => true,
                            'message' => 'File uploaded successfully!',
                            'path' => $path,
                        ]);
                    }else{
                        return response()->json([
                            'success' => false,
                            'message' => 'File upload failed!',
                        ], 400);
                    }
                }

            } else {
                return response()->json([
                    'success' => false,
                    'message' => 'Failed to create user.',
                ], 400);
            }
        }
    }
}
